#!/usr/bin/php
<?php

/// init
	global $ini;
	global $node;

	require(dirname(__FILE__)."/../include/functions.php");
	check_force_run(1);
	init();

	if (get_ini_opt('confgen','mysql-dbgen') === '0') { exit(0); }

	check_update('mysql_update');

### connect to controlled database server
	admDBconnect();

	logme("mysql: Checking users/databases");

//  Get MySQL users
	$arr_mysql_users=array();
	$arr_mysql=array();

	$usql="SELECT `User`, `Password`
		FROM `user`
		WHERE `User` REGEXP '^[0-9]{4}\_'
		ORDER BY `User`;";
	$ures=admDBquery($usql);
	while ($urow=$ures->fetch_assoc())
	{
		$arr_mysql_users[]=$urow['User'];
		$arr_mysql[$urow['User']]['password']=$urow['Password'];
	}

//  Get admin table mysql users
	$arr_admin_users=array();
	$arr_admin=array();

	$nsql="SELECT CONCAT(LPAD(mysql.clientid, 4, '0'),'_',mysql.name) AS username,
		mysql.password AS password,
		PASSWORD(mysql.password) AS encrypt,
		IF(client.active=1, mysql.active, 0) AS active
		FROM mysql
		LEFT JOIN client ON mysql.clientid=client.id
		WHERE mysql.clientid>0 AND mysql.clientid<10000
		AND (client.node=$node OR client.migrate=1)
		ORDER BY username;";
	$nres=DBquery($nsql);
	while ($nrow=$nres->fetch_assoc())
	{
		$arr_admin_users[]=$nrow['username'];
		$arr_admin[$nrow['username']]['password']=$nrow['password'];
		$arr_admin[$nrow['username']]['encrypt']=$nrow['encrypt'];
		$arr_admin[$nrow['username']]['active']=$nrow['active'];
	}

/// Create, check users and databases

	foreach ($arr_admin as $username => $userdata)
	{
		/// Database creation
		$csql="CREATE DATABASE IF NOT EXISTS `$username`;";
		$cres=admDBquery($csql);

		/// Check user, password
		$passwd=$userdata['password'];
		if (!(in_array($username, $arr_mysql_users)))
		{
			//create user or set password
			$ucsql="GRANT USAGE ON *.* TO '$username'@'localhost' IDENTIFIED BY '$passwd' WITH MAX_QUERIES_PER_HOUR 0 MAX_CONNECTIONS_PER_HOUR 0 MAX_UPDATES_PER_HOUR 0 ;";
			$ucres=admDBquery($ucsql);
			logme ("mysql: user/db created: $username");
		}
		else
		{
			if ($userdata['encrypt'] != $arr_mysql[$username]['password'])
			{
				// change password
				$cpsql="SET PASSWORD FOR '$username'@'localhost' = PASSWORD('$passwd');";
				$cpres=admDBquery($cpsql);
				logme ("mysql: Password changed for $username");
			}
		}

		/// Check user-db rights
		$dbsql="SELECT `Db` FROM `db` WHERE `User`='$username' AND `Db`='$username';";
		$dbres=admDBquery($dbsql);
		if ($dbres->num_rows == 0 && $userdata['active'] == 1)
		{
			$dbrsql="GRANT ALL PRIVILEGES ON `$username`.* TO '$username'@'localhost';";
			$dbrres=admDBquery($dbrsql);
			logme ("mysql: Enabled user/db: $username.");
		}
		if ($dbres->num_rows == 1 && $userdata['active'] == 0)
		{
			$dbrrsql="REVOKE ALL PRIVILEGES ON `$username`.* FROM '$username'@'localhost';";
			$dbrrres=admDBquery($dbrrsql);
			logme ("mysql: Disabled user/db: $username.");
		}
	}

	if (count($arr_admin_users) == 0 && count($arr_mysql_users) > 0)
	{
		unlock_update('mysql_update');
		die("DB error: deleting the last mysql user/database is not allowed for security reasons.\n");
	}

	//to delete
	$todelete=array_diff($arr_mysql_users, $arr_admin_users);

	foreach($todelete as $username)
	{
		$dbsql="SELECT `Db` FROM `db` WHERE `User`='$username' AND `Db`='$username';";
		$dbres=admDBquery($dbsql);
		if ($dbres->num_rows == 1)
		{
			$dbrrsql="REVOKE ALL PRIVILEGES ON `$username`.* FROM '$username'@'localhost';";
			$dbrrres=admDBquery($dbrrsql);
		}

		//delete user
		$dbrusql="DROP USER '$username'@'localhost';";
		$dbrures=admDBquery($dbrusql);

		//delete database
		$dbrdsql="DROP DATABASE `$username`;";
		$dbrdres=admDBquery($dbrdsql);
		logme ("mysql: Dropped user/db: $username");
	}

### generate master mysql user for all clients

	// Get MySQL client master users
	$arr_mysql_cusers=array();
	$arr_mysql_c=array();

	$mcusql="SELECT `User`, `Password`
		FROM `user`
		WHERE `User` REGEXP '^[0-9]{4}$'
		ORDER BY `User`;";
	$mcures=admDBquery($mcusql);
	while ($mcurow=$mcures->fetch_assoc())
	{
		$arr_mysql_cusers[]=$mcurow['User'];
		$arr_mysql_c[$mcurow['User']]['password']=$mcurow['Password'];
	}

//  Get sysadmin clients
	$arr_admin_cusers=array();
	$arr_admin_c=array();

	$acusql="SELECT LPAD(id, 4, '0') AS cusername,
		password AS password,
		PASSWORD(password) AS encrypt,
		suspend AS suspend,
		active AS active
		FROM client
		WHERE id>0 AND id<10000
		AND (node=$node OR migrate=1)
		ORDER BY id;";
	$acures=DBquery($acusql);
	while ($acurow=$acures->fetch_assoc())
	{
		$arr_admin_cusers[]=$acurow['cusername'];
		$arr_admin_c[$acurow['cusername']]['password']=$acurow['password'];
		$arr_admin_c[$acurow['cusername']]['encrypt']=$acurow['encrypt'];
		$arr_admin_c[$acurow['cusername']]['suspend']=$acurow['suspend'];
		$arr_admin_c[$acurow['cusername']]['active']=$acurow['active'];
	}

/// Create, check client master users

	foreach ($arr_admin_c as $cusername => $cuserdata)
	{
		/// Check user, password
		$passwd=$cuserdata['password'];
		if (!(in_array($cusername, $arr_mysql_cusers)))
		{
			//create master user or set password
			$cucsql="GRANT USAGE ON *.* TO '$cusername'@'localhost' IDENTIFIED BY '$passwd' WITH MAX_QUERIES_PER_HOUR 0 MAX_CONNECTIONS_PER_HOUR 0 MAX_UPDATES_PER_HOUR 0 MAX_USER_CONNECTIONS 2;";
			$cucres=admDBquery($cucsql);
			logme ("mysql: client master user created: $cusername");

		}
		else
		{
			if ($cuserdata['encrypt'] != $arr_mysql_c[$cusername]['password'])
			{
				// change password
				$ccpsql="SET PASSWORD FOR '$cusername'@'localhost' = PASSWORD('$passwd');";
				$ccpres=admDBquery($ccpsql);
				logme ("mysql: Password changed for client master user: $cusername");
			}
		}

/// Grant or revoke privileges to/from client's all databases

		$cdbsql="SELECT `Db` FROM `db` WHERE `User`='$cusername' AND `Db`='$cusername\_%';";
		$cdbres=admDBquery($cdbsql);
		if ($cdbres->num_rows == 0 && ($cuserdata['suspend'] == 0 && $cuserdata['active'] == 1))
		{
			$dbcrsql="GRANT ALL PRIVILEGES ON `$cusername\_%`.* TO '$cusername'@'localhost';";
			$dbcrres=admDBquery($dbcrsql);
			logme ("mysql: Enabled client master user: $cusername.");
		}
		if ($cdbres->num_rows == 1 && ($cuserdata['suspend'] == 1 || $cuserdata['active'] == 0))
		{
			$dbcrrsql="REVOKE ALL PRIVILEGES ON `$cusername\_%`.* FROM '$cusername'@'localhost';";
			$dbcrrres=admDBquery($dbcrrsql);
			logme ("mysql: Disabled client master user: $cusername.");
		}
	}

// Delete client master users

	// delete check
	if (count($arr_admin_cusers) == 0 && count($arr_mysql_cusers) > 0)
	{
		unlock_update('mysql_update');
		die("DB error: deleting the last mysql client master user is not allowed for security reasons.\n");
	}

	//to delete
	$todelete=array_diff($arr_mysql_cusers, $arr_admin_cusers);

	foreach($todelete as $cusername)
	{
		//revoke privileges
		$cdbrrsql="REVOKE ALL PRIVILEGES, GRANT OPTION FROM '$cusername'@'localhost';";
		$cdbrrres=admDBquery($cdbrrsql);
		//delete user
		$cdbrusql="DROP USER '$cusername'@'localhost';";
		$cdbrures=admDBquery($cdbrusql);
		logme ("mysql: Deleted client master user: $cusername");
	}


### reset update flag

	admDBclose();
	unlock_update('mysql_update');
