#!/usr/bin/php
<?php

/// init
	global $ini;
	global $node;

	require(dirname(__FILE__)."/../include/functions.php");
	init();

	if ($node != '1') { exit(0); }
	if (get_ini_opt('cron','mail-quota-mail') === '0') { exit(0); }

### read configuration options

	$mail_tpl = $ini['global']['template_dir']."/quota-mail.txt";
	$msgbody=file_get_contents($mail_tpl);

	$cmail_subject="E-mail tárhely jelentés";
	$cmail_tpl = $ini['global']['template_dir']."/quota-mail-sum.txt";
	$cmsgbody=file_get_contents($cmail_tpl);

	$mail_fromaddr = $ini['global']['email'];
	$mail_fromname = $ini['global']['name'];

	$perc='91';

### Collect overquota mail accounts

	$sql="SELECT
		`mail_users`.`id` AS `id`,
		CONCAT(
			`mail_users`.`name`,
			'@',
			IF((`dom_host`.`host` IS NULL), '', CONCAT(`dom_host`.`host`,'.')),
			`domain`.`name`
		) AS `email`,
		`client`.`id` AS `clientid`,
		`client`.`name` AS `clientname`,
		`client`.`email` AS `clientmail`,
		`domain`.`name` AS `domain`,
		`dom_host`.`host` AS `host`,
		`mail_users`.`quota` AS `quota`,
		IFNULL(`stats_mail`.`usage`,0) AS `usage`,
		CEIL(IFNULL(`stats_mail`.`usage`, 0)/`mail_users`.`quota`*100) AS `percent`

		FROM `mail_users`
		LEFT JOIN `domain` ON `mail_users`.`domainid`=`domain`.`id`
		LEFT JOIN `dom_host` ON `mail_users`.`hostid`=`dom_host`.`id`
		LEFT JOIN `client` ON `domain`.`clientid`=`client`.`id`
		LEFT JOIN `stats_mail` ON `stats_mail`.`mailid`=`mail_users`.`id`

		WHERE `mail_users`.`active`='1'
		AND `domain`.`active`='1'
		AND `domain`.`mx` IS NULL
		AND `domain`.`transport` IS NULL
		AND `client`.`active`='1'

		HAVING `percent` > ".$perc."

		ORDER BY `client`.`id`, `domain`.`name`, `mail_users`.`name`

	";

	$res=DBquery($sql);

	$client_list=array();

	//send all mails
	while ($row=$res->fetch_assoc()) {

		$client_list[$row['clientmail']][]=$row['email'].' - '.$row['usage'].' MB / '.$row['quota'].' MB ('.$row['percent'].'%)';

		if($row['percent'] < 101)
		{
			$sendbody=str_replace('#QUOTA#', $row['quota'], $msgbody);
			$sendbody=str_replace('#USAGE#', $row['usage'], $sendbody);
			$sendbody=str_replace('#USAGEP#', $row['percent'], $sendbody);

			$mail_subject='E-mail tárhely '.$row['percent'].'% felett';

#			echo "***\n$row[email] - $row[percent]% - $mail_subject\n";
#			echo $sendbody;
			mailsend($mail_fromname, $mail_fromaddr, $row['email'], $mail_subject, $sendbody);
			sleep(1);
		}
	}

	//send digest to the clients
	foreach($client_list as $cmail => $mbl)
	{
		$mblist=implode("\n", $mbl);

		$csendbody=str_replace('#LIST#', $mblist, $cmsgbody);

#		echo "***\n$cmail - $cmail_subject\n";
#		echo $csendbody;
		mailsend($mail_fromname, $mail_fromaddr, $cmail, $cmail_subject, $csendbody);
		sleep(1);
	}

DBclose();
