#!/usr/bin/php
<?php

/// init
global $ini;
global $node;

require(dirname(__FILE__)."/../include/functions.php");
init();

if (get_ini_opt('cron','mail-web-scan') === '0') { exit(0); }

### read configuration options

$webroot=$ini['global']['webroot'];

$mail_tpl = $ini['global']['template_dir']."/virus.txt";
$mailbody=file_get_contents($mail_tpl);

$mail_fromaddr = $ini['global']['email'];
$mail_fromname = $ini['global']['name'];
$mail_subject="FIGYELEM! Fertőzött tartalom a webtárhelyen!";
$mail_subject_root="Virus report on ".$ini['global']['host'];

if ($node!=1) { $mail_subject_root.=" node ".$node; }

### check clamscan or clamdscan

if ( ! (file_exists('/usr/bin/clamdscan') || file_exists('/usr/bin/clamscan') ) )
{
	panic ('ERROR: Antivirus scanner not found.');
}

### set up clamscan or clamdscan

$clamd_sockets=array();
$clamd_socket='';

if (array_key_exists('dovecot',$ini) && array_key_exists('chrdir',$ini['dovecot']) && $ini['dovecot']['chrdir']!="" && file_exists($ini['dovecot']['chrdir']))
{
	$clamd_sockets[]=$ini['dovecot']['chrdir'].'/run/clamav/clamd.ctl';
	$clamd_sockets[]=$ini['dovecot']['chrdir'].'/run/amavis/clamd.ctl';
	$clamd_sockets[]=$ini['dovecot']['chrdir'].'/var/run/clamav/clamd.ctl';
	$clamd_sockets[]=$ini['dovecot']['chrdir'].'/var/run/amavis/clamd.ctl';
}

$clamd_sockets[]='/run/clamav/clamd.ctl';
$clamd_sockets[]='/run/amavis/clamd.ctl';
$clamd_sockets[]='/var/run/clamav/clamd.ctl';
$clamd_sockets[]='/var/run/amavis/clamd.ctl';

foreach ($clamd_sockets as $socket_tmp)
{
	if (file_exists($socket_tmp))
	{
		$clamd_socket=$socket_tmp;
		break;
	}
}

$clamd_config_file = tempnam(sys_get_temp_dir(),'clamdscan');

if ($clamd_socket!='')
{
	$clamd_conf="# clamdscan temporary config
LocalSocket ".$clamd_socket."
ExcludePath \.mp4$
ExcludePath \.avi$
ExcludePath \.mov$
ExcludePath \.mpg$
ExcludePath \.wmv$
ExcludePath \.mp3$
ExcludePath \.iso$
ExcludePath \.dat$
ExcludePath \.zip$
ExcludePath \.rar$
ExcludePath \.7z$
ExcludePath \.tar\.gz$
";

	file_put_contents($clamd_config_file, $clamd_conf);
}

### get clientdirs to scan

$sql ="SELECT name, email, concat('$webroot/',name) AS homedir FROM client WHERE node=$node;";

$result=DBquery($sql);

$reps="";

$virus_clients=array();


while ($row=$result->fetch_assoc())
{
	$clientname=$row['name'];
	$clientdir=$row['homedir'];
	$email=$row['email'];

	if (is_dir($clientdir)) {
		$retval=0;
		$virusscan="";
		$virlist=array();
		if ($clamd_socket!='' && file_exists('/usr/bin/clamdscan'))
		{
			exec("ionice -c3 clamdscan -c ".$clamd_config_file." --fdpass --stream --no-summary -i $clientdir 2>/dev/null", $virlist, $retval);
		}
		else
		{
			exec("ionice -c3 clamscan --no-summary --include=\"\.(php|htm|html|js|htaccess)$\" -r -i $clientdir", $virlist, $retval);
		}
		if ($retval == 1) {
			$virus_clients[]=$clientname;
			$virusscan=implode("\n",$virlist);
			$reps.="$clientname:\n$virusscan\n\n";
			$msgbody=$mailbody."\n".$virusscan."\n";
			if ($email != "") {
				mailsend($mail_fromname, $mail_fromaddr, $email, $mail_subject, $msgbody);
			}
		}
	}
}

unlink($clamd_config_file);

if ($reps!="") {

	$viruslog="/var/log/sysadmin-virus.log";
	fpush($viruslog, $reps."\n", true);
	logme ("VIRUS found: ".implode(', ', $virus_clients));
	//mailsend("VirusScan", "root", "root", $mail_subject_root, $reps);
	//sleep(1);

}

DBclose();

