#!/usr/bin/php
<?php

    function getstats($file) {

	$ret['hits']=0;
	$ret['datamb']=0;
	$ret['cpusec']=0;

	$data=0;
	$cpu=0;

	if (substr($file, -3) == '.gz')
	{
		$gzip=true;
	}
	else
	{
		$gzip=false;
	}

	if ($gzip) { $handle = @gzopen($file, "r"); } else { $handle = @fopen($file, "r"); }

	if ($handle) {

	    while (($line = fgets($handle, 4096)) !== false) {

		$err=preg_match_all('/"(?:\\\\.|[^\\\\"])*"|\[(?:\\\\.|[^\\\\"])*\]|\S+/', $line, $parts);

		if (array_key_exists(6, $parts[0])) {
		    $data+=intval($parts[0][6]);
	        }
		if (array_key_exists(11, $parts[0])) {
		    $cpu+=intval($parts[0][11]);
		}

		$ret['hits']++;
	    }
	    if (!feof($handle)) {
		echo "Error: unexpected fgets() fail\n";
	    }
	    if ($gzip) { gzclose($handle); } else { fclose($handle); }
	}

	$ret['datamb']=round($data/1000000);
	$ret['cpusec']=round($cpu/1000000);

	return $ret;

    }

################################################################################

/// Main script

/// init
    global $ini;
    global $node;

    require(dirname(__FILE__)."/../include/functions.php");
    init();

    if (get_ini_opt('cron','stats-update-vhost') === '0') { exit(0); }

    $ydate=strtotime("yesterday");
    $ymonth=date('m', $ydate);
    $yday=date('d', $ydate);

    $sql="SELECT vhosts.id AS `vhid`,
	    CONCAT(vhosts.host,'.',domain.name) AS `vhname`,
	    `vhosts`.`upstream` AS `upstream`
	    FROM `vhosts`
	    LEFT JOIN `domain` ON `vhosts`.`domainid`=`domain`.`id`
	    LEFT JOIN `client` ON `domain`.`clientid`=`client`.`id`
	    WHERE `client`.`node`='$node' AND `vhosts`.`active`=1 AND `domain`.`active`=1 AND `client`.`active`=1;";

    $res=DBquery($sql);

    while ($srow=$res->fetch_assoc()) {

	$vhid=$srow['vhid'];

	$log=findlog($srow['vhname'], $srow['upstream'], $ini);
	$hits=0;
	$datamb=0;
	$cpusec=0;
	if ($log) {
	    $stat=getstats($log);
	    $hits+=$stat['hits'];
	    $datamb+=$stat['datamb'];
	    $cpusec+=$stat['cpusec'];
	}

	$sqlupd="REPLACE INTO `stats_vhost`
		    SET `vhostid`='$vhid', `month`='$ymonth', `day`='$yday',
			`hits`='$hits', `data`='$datamb', `cpu`='$cpusec';
		";

	$ures=DBquery($sqlupd);
#	echo "$srow[vhname]: $hits hits - $datamb MB - $cpusec s\n";

    }

    DBclose();
