#!/usr/bin/php
<?php

	/// init
	global $ini;
	global $node;

	global $NOLOG;
	$NOLOG = true;

	global $ignore_live;
	$ignore_live = true;

	require(dirname(__FILE__)."/../../include/functions.php");
	init();

	//count number of servers from ini
	$num_servers=count($ini['nodeip']);


#########################################################

	function add_column($table, $column, $alterquery)
	{
		$col_res=DBquery("SHOW COLUMNS FROM `".$table."` LIKE '".$column."'");
		if ($col_res->num_rows==0)
		{
			echo "$alterquery\n";
			DBquery($alterquery);
			return true;
		}
#		echo "COL OK `$table`.`$column` exists\n";
		return false;
	}

	function get_schema_data($table, $column, $metadata)
	{
		global $ini;
		if ($res=DBquery("SELECT `".$metadata."`
				FROM `information_schema`.`COLUMNS`
				WHERE `table_schema`='".$ini['mysql']['db']."'
				AND table_name='".$table."'
				AND column_name='".$column."'
				;", NULL, true))
		{
			$row=$res->fetch_assoc();
			return $row[$metadata];
		}
		else
		{
			return false;
		}
	}

	function get_index_data($table, $column, $idx=NULL)
	{
		global $ini;

		if (!($idx))
		{
			$idx=$column;
		}

		if ($res=DBquery("SHOW INDEXES
				FROM `".$ini['mysql']['db']."`.`".$table."`
				WHERE `Column_name`='".$column."'
				AND `Key_name`='".$idx."'
				;", NULL, true))
		{
			$row=$res->fetch_assoc();
			return $row;
		}
		else
		{
			return false;
		}
	}

	function add_index($table, $column, $idx=NULL, $uniq=false, $length=NULL)
	{
		global $ini;

		if (!($idx))
		{
			$idx=$column;
		}

		$LEN="";
		if ($length)
		{
			$LEN='('.$length.')';
		}

		if ($uniq)
		{
			$INAME="UNIQUE INDEX";
		}
		else
		{
			$INAME="INDEX";
		}

		if (!(get_index_data($table, $column, $idx)))
		{
			$add_sql="ALTER TABLE `".$ini['mysql']['db']."`.`".$table."` ADD ".$INAME." ".$idx." (".$column.$LEN.");";
			echo "$add_sql\n";
			//echo "Adding index: `$idx`(`$column`)@`$table`\n";
			DBquery($add_sql);
		}
		else
		{
#			echo "IDX OK `$idx`(`$column`)@`$table`\n";
		}
	}

	function add_var($key, $def, $allnodes=true)
	{
		if ($allnodes==true)
		{
			global $num_servers;
			$ns=$num_servers;
		}
		else
		{
			$ns=1;
		}
		for ($nn=1; $nn<=$ns; $nn++) {
			$res=DBquery("SELECT `key` FROM `var` WHERE `key`='$key' AND `node`='$nn';");
			if ($res->num_rows==0) {
				DBquery("INSERT INTO `var` SET `key`='$key', `node`='$nn', `value`='$def', `lock`=0, `modified`=NOW();");
			}
		}
	}

	function create_token($length=32)
	{
		//min.length=32
		if ($length<32) { $length=32; }

		$set_all=str_shuffle("abcdefghijkmnopqrstuvwxyz1234567890");

		$password="";
		for ($i=1; $i<=$length; $i++)
		{
			$password .= $set_all[mt_rand(0,strlen($set_all)-1)];
		}

		return str_shuffle($password);
	}


#########################################################

echo "Checking sysadmin DB schema...\n";

# check and add vars
add_var("serial",1,false);
add_var("date","20000101",false);
add_var("bind_update",0,false);

add_var("apache_update",0,true);
add_var("rights_update",0,true);
add_var("ssl_update",0,true);
add_var("deploy",0,true);

add_var("mysql_update",0,true);
add_var("opendkim_update",0,true);

/// Run the db schema updater

# suspend flag
add_column ( 'client', 'suspend', "ALTER TABLE  `client` ADD `suspend` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT  '0' AFTER  `active`;" );
# migrate flag (to move between servers)
add_column ( 'client', 'migrate', "ALTER TABLE  `client` ADD `migrate` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT  '0' AFTER  `suspend`;" );

# create stats table
DBquery("CREATE TABLE IF NOT EXISTS `stats_vhost` (
      `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
      `vhostid` int(10) unsigned NOT NULL,
      `month` tinyint(3) unsigned NOT NULL,
      `day` tinyint(3) unsigned NOT NULL,
      `hits` bigint(20) unsigned NOT NULL,
      `data` bigint(20) unsigned NOT NULL,
      `cpu` bigint(20) unsigned NOT NULL,
      `modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
      PRIMARY KEY (`id`),
      UNIQUE KEY `vhdm` (`vhostid`,`month`,`day`)
        ) DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='VHost stats';");

# sys_admin_r can update stats
#DBquery("GRANT Select,Insert,Update,Delete on ".$ini['mysql']['db'].".stats_ftp to ".$ini['mysql']['user']."@localhost ;");
#DBquery("GRANT Select,Insert,Update,Delete on ".$ini['mysql']['db'].".stats_mail to ".$ini['mysql']['user']."@localhost ;");
#DBquery("GRANT Select,Insert,Update,Delete on ".$ini['mysql']['db'].".stats_vhost to ".$ini['mysql']['user']."@localhost ;");

# vhosts.writable (dirs to make writable automatically on autofix + check for writable dirs)
$wdirs="cache\nadministrator/cache\nlog\nlogs\ntmp\nwp-content/uploads";
add_column ( 'vhosts', 'writable', "ALTER TABLE `vhosts` ADD `writable` VARCHAR(1024) CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT '$wdirs' COMMENT 'Writable dirs' AFTER `settings`;" );
DBquery("ALTER TABLE `vhosts` CHANGE `writable` `writable` VARCHAR(1024) CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT NULL COMMENT 'Writable dirs';");

# vhosts.rights flag (0-OK, 1-ERR, 2-DO_FIX, 3-DO_WRITABLE)
add_column ( 'vhosts', 'rights', "ALTER TABLE `vhosts` ADD `rights` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `writable`;" );
# sys_admin_r can update vhosts.rights
#DBquery("GRANT UPDATE(`rights`) on ".$ini['mysql']['db'].".`vhosts` to ".$ini['mysql']['user']."@localhost ;");

add_column ( 'vhosts', 'upstream', "ALTER TABLE `vhosts` ADD `upstream` VARCHAR( 16 ) NULL DEFAULT NULL AFTER `settings`;" );

if ( add_column ( 'vhosts', 'token', "ALTER TABLE `vhosts` ADD `token` VARCHAR( 255 ) NULL DEFAULT NULL AFTER `upstream`;" ) )
{
	$vhres=DBquery("SELECT `id` FROM `vhosts`");
	DBquery("SET autocommit = 0;");
	DBquery("START TRANSACTION;");
	while($vhrow=$vhres->fetch_assoc())
	{
		$token=create_token(32);
		$vhid=$vhrow['id'];
		DBquery("UPDATE `vhosts` SET `token`='$token' WHERE `id`='$vhid';");
	}
	DBquery("COMMIT;");
	DBquery("SET autocommit = 1;");
}

DBquery("CREATE TABLE IF NOT EXISTS `deploy` (
	`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
	`vhostid` int(11) unsigned NOT NULL,
	`repo_address` varchar(255) CHARACTER SET utf8 COLLATE utf8_hungarian_ci NOT NULL,
	`login` varchar(64) COLLATE utf8_bin NOT NULL,
	`password` varchar(255) COLLATE utf8_bin NOT NULL,
	`branch` varchar(64) COLLATE utf8_bin DEFAULT NULL,
	`deploy` BOOLEAN NOT NULL DEFAULT FALSE,
	PRIMARY KEY (`id`),
	UNIQUE KEY (`vhostid`)
	) DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='Autodeploy'; ");

# sys_admin_r can update deploy.deploy
#DBquery("GRANT UPDATE(`deploy`) on ".$ini['mysql']['db'].".`deploy` to ".$ini['mysql']['user']."@localhost ;");

add_column ( 'domain', 'spf', "ALTER TABLE `domain` ADD `spf` VARCHAR( 255 ) NULL DEFAULT NULL COMMENT 'SPF extra' AFTER `mx`;" );

# add nginx extra settings
add_column ( 'vhosts', 'nsettings', "ALTER TABLE `vhosts` ADD `nsettings` TEXT NULL DEFAULT NULL COMMENT 'extra Nginx settings' AFTER `settings`;" );

DBquery("CREATE TABLE IF NOT EXISTS `stats_mysql` (
		`id` int(10) unsigned NOT NULL AUTO_INCREMENT,
		`clientid` int(10) unsigned NOT NULL,
		`mysqlid` int(10) unsigned NOT NULL,
		`tables` bigint(20) unsigned NOT NULL DEFAULT '0',
		`rows` bigint(20) unsigned NOT NULL DEFAULT '0',
		`data` bigint(20) unsigned NOT NULL DEFAULT '0',
		`idx` bigint(20) unsigned NOT NULL DEFAULT '0',
		`modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
		PRIMARY KEY (`id`),
		UNIQUE KEY `clidbid` (`clientid`,`mysqlid`)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='MySQL usage';");

# sys_admin_r can update mysql stats
#DBquery("GRANT Select,Insert,Update,Delete on ".$ini['mysql']['db'].".stats_mysql to ".$ini['mysql']['user']."@localhost ;");

# add mailquota field
if (add_column ( 'client', 'mailquota', "ALTER TABLE `client` ADD `mailquota` INT UNSIGNED NOT NULL DEFAULT '2000' AFTER `quota`;" ))
{
	DBquery("UPDATE `client` SET `mailquota`=`quota`*4;");
}

add_column ( 'deploy', 'last', "ALTER TABLE `deploy` ADD `last` TIMESTAMP NULL DEFAULT NULL AFTER `deploy`;" );
add_column ( 'deploy', 'modified', "ALTER TABLE `deploy` ADD `modified` TIMESTAMP on update CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP AFTER `last`;" );

# sys_admin_r can update deploy.last
#DBquery("GRANT UPDATE(`last`) on ".$ini['mysql']['db'].".`deploy` to ".$ini['mysql']['user']."@localhost ;");

add_column ( 'deploy', 'hook_pre', "ALTER TABLE `deploy` ADD `hook_pre` VARCHAR( 255 ) NULL DEFAULT NULL COMMENT 'Pre-update hook' AFTER `branch`;" );
add_column ( 'deploy', 'hook_post', "ALTER TABLE `deploy` ADD `hook_post` VARCHAR( 255 ) NULL DEFAULT NULL COMMENT 'Post-update hook' AFTER `hook_pre`;" );


add_column ( 'vhosts', 'ssl_on', "ALTER TABLE `vhosts` ADD `ssl_on` TINYINT UNSIGNED NOT NULL DEFAULT '0' COMMENT 'https' AFTER `nsettings`;" );
add_column ( 'vhosts', 'ssl_mode', "ALTER TABLE `vhosts` ADD `ssl_mode` TINYINT UNSIGNED NOT NULL DEFAULT '0' COMMENT 'https mode' AFTER `ssl_on`;" );

# sys_admin_r can update vhosts.ssl_on
#DBquery("GRANT UPDATE(`ssl_on`) on ".$ini['mysql']['db'].".`vhosts` to ".$ini['mysql']['user']."@localhost ;");

# add admin level (1-5)
add_column ( 'admin', 'level', "ALTER TABLE `admin` ADD `level` TINYINT UNSIGNED NOT NULL DEFAULT '5' AFTER `password`;" );
# add user category (1-5)
add_column ( 'client', 'category', "ALTER TABLE `client` ADD `category` TINYINT UNSIGNED NOT NULL DEFAULT '1' AFTER `email`;" );


# change dom record max length to 4096
if (get_schema_data('dom_records', 'value', 'character_maximum_length') < 4096)
{
	DBquery("ALTER TABLE `dom_records` CHANGE `value` `value` VARCHAR(4096);");
}

if (get_schema_data('mail_users', 'password', 'character_maximum_length') < 64)
{
	DBquery("ALTER TABLE `mail_users` CHANGE `password` `password` VARCHAR(64);");
}

add_column ( 'mail_users', 'old_password', "ALTER TABLE `mail_users` ADD `old_password` VARCHAR(64) CHARACTER SET utf8 COLLATE utf8_hungarian_ci NULL DEFAULT NULL COMMENT 'encrypted' AFTER `password`;" );

# change redirect length
if (get_schema_data('vhosts', 'redirect', 'character_maximum_length') < 1024)
{
	DBquery("ALTER TABLE `vhosts` CHANGE `redirect` `redirect` VARCHAR(1024);");
}

# change writable dirs length
if (get_schema_data('vhosts', 'writable', 'character_maximum_length') < 8192)
{
	DBquery("ALTER TABLE `vhosts` CHANGE `writable` `writable` VARCHAR(8192);");
}


# change domain.mx to varchar(1024)
if (get_schema_data('domain', 'mx', 'data_type') != 'varchar')
{
	DBquery("ALTER TABLE `domain` CHANGE `mx` `mx` VARCHAR(1024) CHARACTER SET utf8 COLLATE utf8_hungarian_ci NULL DEFAULT NULL COMMENT 'MX (null = local)';");
}

# change dom_host.mx to varchar(1024)
if (get_schema_data('dom_host', 'mx', 'data_type') != 'varchar')
{
	DBquery("ALTER TABLE `dom_host` CHANGE `mx` `mx` VARCHAR(1024) CHARACTER SET utf8 COLLATE utf8_hungarian_ci NULL DEFAULT NULL COMMENT 'MX (null = parent)';");
}

add_column ( 'ftp', 'iprestrict', "ALTER TABLE `ftp` ADD `iprestrict` VARCHAR(15) CHARACTER SET utf8 COLLATE utf8_hungarian_ci NULL DEFAULT NULL AFTER `active`;" );
add_column ( 'ftp', 'plainftp', "ALTER TABLE `ftp` ADD `plainftp` TINYINT(1) NULL DEFAULT NULL AFTER `iprestrict`;" );


# add some indexes @210504
add_index('client', 'name', 'name', true);
add_index('client', 'node');
add_index('client', 'active');
add_index('client', 'suspend');
add_index('client', 'migrate');

add_index('cli_ftp', 'active');

add_index('deploy', 'deploy');
add_index('deploy', 'last');

add_index('domain', 'name', 'name', true);
add_index('domain', 'clientid');
add_index('domain', 'dns');
add_index('domain', 'transport');
add_index('domain', 'mx', 'mx', false, 64);
add_index('domain', 'active');

add_index('dom_host', 'transport');
add_index('dom_host', 'mx', 'mx', false, 64);
add_index('dom_host', 'active');

add_index('dom_records', 'active');

add_index('ftp', 'active');
add_index('ftp', 'iprestrict');
add_index('ftp', 'plainftp');

add_index('mail_aliases', 'active');

add_index('mail_sbcc', 'active');

add_index('mail_users', 'active');

add_index('mysql', 'active');

add_index('stats_vhost', 'modified');

add_index('vhosts', 'ssl_on');
add_index('vhosts', 'ssl_mode');
add_index('vhosts', 'rights');
add_index('vhosts', 'active');


# add dkim column to domain and dom_host @211015

add_column ( 'domain', 'dkim', "ALTER TABLE `domain` ADD `dkim` BOOLEAN NOT NULL DEFAULT FALSE COMMENT 'Force DKIM' AFTER `spf`;" );
add_index ('domain', 'dkim');

add_column ( 'dom_host', 'dkim', "ALTER TABLE `dom_host` ADD `dkim` BOOLEAN NOT NULL DEFAULT FALSE COMMENT 'Force DKIM' AFTER `mx`;" );
add_index ('dom_host', 'dkim');

# add http redirect type (permanent=301, temp=302)
add_column ( 'vhosts', 'redirect_permanent', "ALTER TABLE `vhosts` ADD `redirect_permanent` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0 COMMENT '301' AFTER `redirect`;" );

add_column ( 'mail_users', 'smtp', "ALTER TABLE `mail_users` ADD `smtp` BOOLEAN NOT NULL DEFAULT TRUE AFTER `quota`;" );
add_index ('mail_users', 'smtp');

add_column ( 'domain', 'dmarc', "ALTER TABLE `domain` ADD `dmarc` VARCHAR( 255 ) NULL DEFAULT NULL COMMENT 'DMARC' AFTER `spf`;" );

#########################################################

echo "Done.\n";
