-- MySQL dump 10.19  Distrib 10.3.31-MariaDB, for debian-linux-gnu (x86_64)
--
-- Host: localhost    Database: sys_admin_test
-- ------------------------------------------------------
-- Server version	10.3.31-MariaDB-0+deb10u1-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `admin`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `admin` (
  `name` varchar(32) COLLATE utf8_hungarian_ci NOT NULL,
  `password` varchar(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT 'PASSWORD()',
  `level` tinyint(3) unsigned NOT NULL DEFAULT 5,
  `active` tinyint(1) unsigned NOT NULL DEFAULT 1,
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='Administrators';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `cli_ftp`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `cli_ftp` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `clientid` int(10) unsigned NOT NULL,
  `name` varchar(32) COLLATE utf8_hungarian_ci NOT NULL,
  `password` varchar(32) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `quota` int(10) unsigned NOT NULL DEFAULT 500,
  `subdir` varchar(128) COLLATE utf8_hungarian_ci NOT NULL,
  `active` tinyint(1) unsigned NOT NULL DEFAULT 1,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `clidom` (`clientid`,`name`),
  KEY `active` (`active`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='Client FTP users';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `client`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `client` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(32) COLLATE utf8_hungarian_ci NOT NULL,
  `password` varchar(32) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `old_password` varchar(64) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `email` varchar(128) COLLATE utf8_hungarian_ci NOT NULL,
  `category` tinyint(3) unsigned NOT NULL DEFAULT 1,
  `node` tinyint(4) NOT NULL DEFAULT 1,
  `quota` int(10) unsigned NOT NULL DEFAULT 500,
  `mailquota` int(10) unsigned NOT NULL DEFAULT 2000,
  `hosting` tinyint(1) unsigned NOT NULL DEFAULT 1,
  `active` tinyint(1) unsigned NOT NULL DEFAULT 1,
  `suspend` tinyint(1) unsigned NOT NULL DEFAULT 0,
  `migrate` tinyint(1) unsigned NOT NULL DEFAULT 0,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `node` (`node`),
  KEY `active` (`active`),
  KEY `suspend` (`suspend`),
  KEY `migrate` (`migrate`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='Clients';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `cron`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `cron` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `vhostid` int(11) unsigned NOT NULL,
  `min` varchar(5) COLLATE utf8_hungarian_ci NOT NULL COMMENT 'min (*/x for every x min)',
  `hour` tinyint(3) unsigned DEFAULT NULL COMMENT 'hour (1-23) (null=*)',
  `dom` tinyint(3) unsigned DEFAULT NULL COMMENT 'day (1-31) (null=*)',
  `month` tinyint(3) unsigned DEFAULT NULL COMMENT 'month (1-12) (null=*)',
  `dow` tinyint(3) unsigned DEFAULT NULL COMMENT 'weekday (1-7) (null=*)',
  `url` varchar(255) COLLATE utf8_hungarian_ci NOT NULL,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  KEY `vhostid` (`vhostid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `deploy`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `deploy` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `vhostid` int(11) unsigned NOT NULL,
  `repo_address` varchar(255) COLLATE utf8_hungarian_ci NOT NULL,
  `login` varchar(64) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `password` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `branch` varchar(64) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `hook_pre` varchar(255) COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'Pre-update hook',
  `hook_post` varchar(255) COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'Post-update hook',
  `deploy` tinyint(1) NOT NULL DEFAULT 0,
  `last` timestamp NULL DEFAULT NULL,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `vhostid` (`vhostid`),
  KEY `deploy` (`deploy`),
  KEY `last` (`last`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='Autodeploy';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dom_host`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `dom_host` (
  `domainid` int(11) unsigned NOT NULL,
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `host` varchar(128) COLLATE utf8_hungarian_ci NOT NULL,
  `transport` varchar(64) COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'transport (null if virtual)',
  `ip` varchar(15) COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'IP (null = local)',
  `mx` varchar(1024) COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'MX (null = parent)',
  `dkim` tinyint(1) NOT NULL DEFAULT 0 COMMENT 'Force DKIM',
  `active` tinyint(1) unsigned NOT NULL DEFAULT 1,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `domhost` (`domainid`,`host`),
  KEY `domainid` (`domainid`),
  KEY `transport` (`transport`),
  KEY `mx` (`mx`(64)),
  KEY `active` (`active`),
  KEY `dkim` (`dkim`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='Hosts (subdomains)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dom_records`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `dom_records` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `domainid` int(10) unsigned NOT NULL,
  `host` varchar(64) COLLATE utf8_hungarian_ci NOT NULL DEFAULT '@' COMMENT '@=domain',
  `type` enum('A','MX','CNAME','NS','TXT','SPF','AAAA','SRV') COLLATE utf8_hungarian_ci NOT NULL DEFAULT 'A',
  `value` varchar(4096) COLLATE utf8_hungarian_ci DEFAULT NULL,
  `active` tinyint(1) unsigned NOT NULL DEFAULT 1,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  KEY `domainid` (`domainid`),
  KEY `active` (`active`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='DNS records';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `domain`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `domain` (
  `clientid` int(11) unsigned NOT NULL,
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(128) COLLATE utf8_hungarian_ci NOT NULL,
  `dns` tinyint(1) unsigned NOT NULL DEFAULT 1 COMMENT 'DNS',
  `domreg` tinyint(1) unsigned NOT NULL DEFAULT 1 COMMENT 'nalunk',
  `transport` varchar(64) COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'transport (null = virtual)',
  `ip` varchar(15) COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'IP (null = local)',
  `mx` varchar(1024) COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'MX (null = local)',
  `spf` varchar(255) COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'SPF extra',
  `dkim` tinyint(1) NOT NULL DEFAULT 0 COMMENT 'Force DKIM',
  `active` tinyint(1) unsigned NOT NULL DEFAULT 1,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `clientid` (`clientid`),
  KEY `dns` (`dns`),
  KEY `transport` (`transport`),
  KEY `mx` (`mx`(64)) USING BTREE,
  KEY `active` (`active`) USING BTREE,
  KEY `dkim` (`dkim`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='Domain';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `ftp`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `ftp` (
  `name` varchar(32) COLLATE utf8_hungarian_ci NOT NULL,
  `password` varchar(32) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `uid` int(11) unsigned NOT NULL DEFAULT 5500,
  `gid` int(10) unsigned NOT NULL DEFAULT 33,
  `quota` int(10) unsigned NOT NULL DEFAULT 0,
  `dir` varchar(128) COLLATE utf8_hungarian_ci NOT NULL DEFAULT '/web/user',
  `active` tinyint(1) unsigned NOT NULL DEFAULT 1,
  `iprestrict` varchar(15) COLLATE utf8_hungarian_ci DEFAULT NULL,
  `plainftp` tinyint(4) DEFAULT NULL,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`name`),
  KEY `active` (`active`),
  KEY `iprestrict` (`iprestrict`),
  KEY `plainftp` (`plainftp`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='Custom FTP users';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mail_aliases`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `mail_aliases` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `domainid` int(11) unsigned DEFAULT NULL,
  `hostid` int(11) unsigned DEFAULT NULL,
  `alias` varchar(32) COLLATE utf8_hungarian_ci DEFAULT NULL,
  `goto` text COLLATE utf8_hungarian_ci NOT NULL,
  `active` tinyint(1) unsigned NOT NULL DEFAULT 1,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `domhalias` (`domainid`,`hostid`,`alias`) USING BTREE,
  KEY `active` (`active`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='Mail users';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mail_sbcc`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `mail_sbcc` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `domainid` int(11) unsigned DEFAULT NULL,
  `hostid` int(11) unsigned DEFAULT NULL,
  `sender` varchar(32) COLLATE utf8_hungarian_ci NOT NULL,
  `bcc` text COLLATE utf8_hungarian_ci NOT NULL,
  `active` tinyint(1) unsigned NOT NULL DEFAULT 1,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `domalias` (`domainid`,`hostid`,`sender`),
  KEY `active` (`active`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='Mail Sender BCC';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mail_users`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `mail_users` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `domainid` int(11) unsigned DEFAULT NULL,
  `hostid` int(10) unsigned DEFAULT NULL,
  `name` varchar(32) COLLATE utf8_hungarian_ci NOT NULL,
  `password` varchar(64) COLLATE utf8_hungarian_ci DEFAULT NULL,
  `old_password` varchar(64) COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'encrypted',
  `quota` int(11) unsigned NOT NULL DEFAULT 2048,
  `active` tinyint(1) unsigned NOT NULL DEFAULT 1,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `domainid` (`domainid`,`hostid`,`name`),
  KEY `active` (`active`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='Mail users';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mysql`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `mysql` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `clientid` int(11) unsigned NOT NULL,
  `name` varchar(11) COLLATE utf8_hungarian_ci NOT NULL COMMENT 'user/table',
  `password` varchar(32) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `active` tinyint(3) unsigned NOT NULL DEFAULT 1,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `clientdbname` (`clientid`,`name`),
  KEY `active` (`active`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='Client mysql databases';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `stats_ftp`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `stats_ftp` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `clientid` int(10) unsigned NOT NULL,
  `ftpid` int(10) unsigned DEFAULT NULL,
  `usage` int(10) unsigned NOT NULL,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `cliftpid` (`clientid`,`ftpid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='FTP Quota usage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `stats_mail`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `stats_mail` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `mailid` int(10) unsigned NOT NULL,
  `usage` int(10) unsigned NOT NULL,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `cliftpid` (`mailid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='FTP Quota usage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `stats_mysql`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `stats_mysql` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `clientid` int(10) unsigned NOT NULL,
  `mysqlid` int(10) unsigned NOT NULL,
  `tables` bigint(20) unsigned NOT NULL DEFAULT 0,
  `rows` bigint(20) unsigned NOT NULL DEFAULT 0,
  `data` bigint(20) unsigned NOT NULL DEFAULT 0,
  `idx` bigint(20) unsigned NOT NULL DEFAULT 0,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `clidbid` (`clientid`,`mysqlid`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='MySQL usage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `stats_vhost`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `stats_vhost` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `vhostid` int(10) unsigned NOT NULL,
  `month` tinyint(3) unsigned NOT NULL,
  `day` tinyint(3) unsigned NOT NULL,
  `hits` bigint(20) unsigned NOT NULL,
  `data` bigint(20) unsigned NOT NULL,
  `cpu` bigint(20) unsigned NOT NULL,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `vhdm` (`vhostid`,`month`,`day`),
  KEY `modified` (`modified`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci COMMENT='FTP Quota usage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `var`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `var` (
  `key` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `node` tinyint(3) unsigned NOT NULL DEFAULT 1,
  `value` int(11) unsigned NOT NULL,
  `lock` tinyint(1) NOT NULL DEFAULT 0,
  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`key`,`node`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `vhosts`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `vhosts` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `domainid` int(11) unsigned NOT NULL,
  `host` varchar(64) COLLATE utf8_hungarian_ci NOT NULL DEFAULT 'www',
  `alias` text COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'host',
  `ext_alias` text COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'URL',
  `redirect` varchar(1024) COLLATE utf8_hungarian_ci DEFAULT NULL,
  `redirect_permanent` tinyint(1) UNSIGNED NOT NULL DEFAULT 0 COMMENT '301',
  `docroot` varchar(128) COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT '(null=/)',
  `extradir` text COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'extra open_basedir',
  `charset` varchar(10) COLLATE utf8_hungarian_ci DEFAULT NULL,
  `settings` text COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'extra Apache settings',
  `nsettings` text COLLATE utf8_hungarian_ci DEFAULT NULL COMMENT 'extra Nginx settings',
  `ssl_on` tinyint(3) unsigned NOT NULL DEFAULT 0 COMMENT 'https',
  `ssl_mode` tinyint(3) unsigned NOT NULL DEFAULT 0 COMMENT 'https mode',
  `upstream` varchar(16) COLLATE utf8_hungarian_ci DEFAULT NULL,
  `token` varchar(255) COLLATE utf8_hungarian_ci DEFAULT NULL,
  `writable` varchar(8192) COLLATE utf8_hungarian_ci DEFAULT NULL,
  `rights` tinyint(1) unsigned NOT NULL DEFAULT 0,
  `active` tinyint(1) unsigned NOT NULL DEFAULT 1,
  `modified` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`),
  UNIQUE KEY `domhost` (`domainid`,`host`),
  KEY `ssl_on` (`ssl_on`),
  KEY `ssl_mode` (`ssl_mode`),
  KEY `rights` (`rights`),
  KEY `active` (`active`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_hungarian_ci;
/*!40101 SET character_set_client = @saved_cs_client */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2021-10-26  3:22:27
