#!/usr/bin/php
<?php

//generate password
	function createpassword($length=32)
	{

		if ($length<16) { $length=16; }

		$char_set='abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNOPQRSTUVWXYZ234567890-.^';

		$password='';

		for ($i=0; $i<$length; $i++)
		{
			str_shuffle($char_set);
			$password.= $char_set[mt_rand(0,strlen($char_set)-1)];
		}

		return ($password);
	}

/// init
	global $ini;
	global $node;

	require(dirname(__FILE__)."/../include/functions.php");
	init(1);

### Parse command line args

	$force=0;
	if (count($argv)>1)
	{
		$cli_id_name=$argv[1];
		if (count($argv)>2 && $argv[2]=='FORCE')
		{
			$force=1;
		}
	}
	else
	{
		echo "Usage: $argv[0] [clientname|clientid] [FORCE]\n";
		exit(1);
	}

### Get ini vars

	$chrdir='/chroot/deploy';

	$webdir=$ini['global']['webroot'];
	$first_uid=$ini['global']['firstuid'];

### Check if all dirs exist

	if (!(file_exists($chrdir)))
	{
		echo "ERROR: Deploy chroot not found.\n";
		exit (10);
	}

	if (!(file_exists($webdir)))
	{
		echo "ERROR: $webdir missing!\n";
		exit (11);
	}

	if (!(file_exists($chrdir.$webdir)))
	{
		echo "ERROR: ".$chrdir.$webdir." missing!\n";
		exit (12);
	}

### Collect client data

	$sql="SELECT
			`client`.`id` AS cliid,
			LPAD(`client`.`id`, 4, '0') AS clicode,
			`client`.`name` AS cliname
		FROM `client`
		WHERE `client`.`node`='".$ini['global']['node']."'
	";

	if (preg_match('~[0-9]+~', $cli_id_name))
	{
		$sql.="
		AND `client`.`id`='$cli_id_name'";
	}
	else
	{
		$sql.="
		AND `client`.`name`='$cli_id_name'";
	}

	$sql.=";";

	$res=DBquery($sql);

	if ($res->num_rows!=1)
	{
		echo "ERROR: No such client: $cli_id_name.\n";
		exit (24);
	}
	$row=$res->fetch_assoc();

	$cl_id=$row['cliid'];
	$cl_code=$row['clicode'];
	$cl_name=$row['cliname'];

	DBclose();

	$clientdir=$webdir.'/'.$cl_name;
	$clienthome=$clientdir.'/_ssh';
	$clientuid=$first_uid+$cl_id;

	$username='web-'.$cl_name;

### Check user

	exec("/usr/sbin/chroot $chrdir /usr/bin/getent passwd ".$username." 2>&1", $uout, $uret);
	exec("/usr/sbin/chroot $chrdir /usr/bin/getent passwd ".$clientuid." 2>&1", $uidout, $uidret);

### Create user or check/change password

	if (($uret != 0 && $uidret != 0) || ($uret==0 && $uidret==0 && $force==1))
	{

		$password=createpassword();

		if (!(file_exists($clientdir)))
		{
			mkdir($clientdir,0755);
			chown($clientdir, $clientuid);
			chgrp($clientdir, 33);
		}

		if (!(file_exists($clienthome)))
		{
			mkdir($clienthome,0700);
			chown($clienthome, $clientuid);
			chgrp($clienthome, 33);
		}

		if ($uret!=0)
		{
			exec('/usr/sbin/chroot '.$chrdir.' /usr/sbin/adduser --home '.$clienthome.' --no-create-home --uid '.$clientuid.' --gecos "" --disabled-password --shell /bin/bash --ingroup www-data '.$username, $cuout, $curet);
			if ($curet!=0)
			{
				print_r($cuout);
				exit (20);
			}
		}

		exec('/usr/sbin/chroot '.$chrdir.' /usr/sbin/usermod --password $(echo "'.$password.'" | /usr/bin/openssl passwd -1 -stdin) '.$username, $puout, $puret);
		if ($puret!=0)
		{
			print_r($puout);
			exit (20);
		}

		if ($uret!=0)
		{
			echo "SSH user $username created.\n";
		}
		else
		{
			echo "SSH user $username updated.\n";
		}
		echo "Login: $username\n";
		echo "Pass : $password\n";
		echo "Dir  : $clientdir\n";
	}
	elseif ($uret!=0 && $uidret==0)
	{
		echo "User $username doesn't exist but found other user with uid $clientuid. Please resolve manually.\n";
		print_r($uidout);
		exit (3);
	}
	else
	{
		echo "User $username already exists. Use FORCE to change password.\n";
		exit (3);
	}
