#!/usr/bin/php
<?php

	// to add extra ip:
	// add an [oldip] group to ini file (like in nodeip)

#	$extra['dns']='ns1.xxx';
#	$extra['mx']='mail.xxx';

###################################################################

	$dns_recursors=array('1.1.1.1','8.8.8.8','8.8.4.4');

	$extra['extra']=1;

###################################################################

	function in_array_array($whats=array(), $where=array())
	{
		foreach ($whats as $what)
		{
			if(in_array($what, $where))
			{
				return true;
			}
		}
		return false;
	}

	function get_local_data($extra)
	{
		global $ini;
		$local=array();

		if (array_key_exists('dns', $extra))
		{
			$local['dns']=$extra['dns'];
		}
		else
		{
			$local['dns']="ns1.".$ini['global']['domain'];
		}

		if (array_key_exists('mx', $extra))
		{
			$local['mx']=$extra['mx'];
		}
		else
		{
			$local['mx']="mail.".$ini['global']['domain'];
		}

		$local['ips']=$ini['nodeip'];
		if (array_key_exists('oldip', $ini))
		{
			foreach($ini['oldip'] as $extra_ip)
			{
				$local['ips'][]=$extra_ip;
			}
		}

		return $local;
	}

###################################################################

	global $ini;
	global $node;

	// log errors to the screen instead of syslog
	global $NOLOG;
	$NOLOG=true;

	require(dirname(__FILE__)."/../include/functions.php");
	init(1);

	$local=get_local_data($extra);

	$dres=DBquery("SELECT	`domain`.`name` AS `name`,
				`domain`.`id` AS `id`,
				`domain`.`dns` AS `dns`,
				IF((`client`.`active`=1), `domain`.`ip`, NULL) AS `ip`,
				IF((`client`.`active`=1), `domain`.`mx`, NULL) AS `mx`
				FROM `domain`
				LEFT JOIN `client` ON `domain`.`clientid`=`client`.`id`
				WHERE `domain`.`active`=1
				AND `domain`.`name` NOT LIKE '%.null'
				AND `domain`.`name` NOT LIKE '%.vacation'
				ORDER BY `domain`.`name`
				;");

	while($drow=$dres->fetch_assoc())
	{
		$test['exist']=1;
		$test['error']=1;
		$test['ns']=1;
		$test['a']=1;
		$test['mx']=1;
		$test['summary']=0;

		$domainid=$drow['id'];
		$domain=$drow['name'];
		$dom_parts=explode('.',$domain,2);
		$tld=end($dom_parts);

		shuffle($dns_recursors);
		$dns_recursor=$dns_recursors[0];

		$nic_servers=array();
		exec("dig NS $tld @$dns_recursor | grep '^$tld' |grep NS | awk '{print $5}'", $nic_servers);

		$dns_nic=rtrim($nic_servers[0],'.');

		$auth_servers=array();
		exec("dig NS $domain @$dns_nic | grep '^$domain' |grep NS | awk '{print $5}'", $auth_servers);

		if (count($auth_servers)>0)
		{
			//domain ok

			// NS match
			if (!in_array($local['dns'].'.', $auth_servers))
			{
				foreach ($auth_servers as $dom_ns)
				{
					$dom_ns=rtrim($dom_ns,'.');
					$ns_ips=array();
					exec("dig A $dom_ns @$dns_recursor | grep '^$dom_ns' | grep -E '[^ \t]*[ \t]*[0-9]*[ \t]*IN[ \t]*A' | awk '{print $5}'", $ns_ips);
					if (count($ns_ips)>0)
					{
						if (!in_array_array($local['ips'], $ns_ips))
						{
							$test['ns']=0;
						}
						else
						{
							$test['ns']=1;
							break;
						}
					}
					else
					{
						$test['ns']=0;
					}
				}
			}

			// A match
			$a_ips=array();
			exec("dig A $domain @$dns_recursor | grep '^$domain' | grep -E '[^ \t]*[ \t]*[0-9]*[ \t]*IN[ \t]*A' | awk '{print $5}'", $a_ips);
			if (count($a_ips)>0)
			{
				// has A record
				if (!in_array_array($local['ips'], $a_ips))
				{
					$test['a']=0;
				}
			}
			else
			{
				$test['a']=0;
			}

			// WWW A match (only if A doesn't)
			if ($test['a']==0)
			{
				$www_ips=array();
				exec("dig A www.$domain @$dns_recursor | grep '^www.$domain' | grep -E '[^ \t]*[ \t]*[0-9]*[ \t]*IN[ \t]*A' | awk '{print $5}'", $www_ips);
				if (count($www_ips)>0)
				{
					// WWW has A record
					if (in_array_array($local['ips'], $www_ips))
					{
						$test['a']=1;
					}
				}
			}

			// MX match
			$mxs=array();
			exec("dig MX $domain @$dns_recursor | grep '^$domain' | grep -E '[^ \t]*[ \t]*[0-9]*[ \t]*IN[ \t]*MX' | awk '{print $6}'", $mxs);
			if (count($mxs)>0)
			{
				if (!in_array($local['mx'].'.', $mxs))
				{
					foreach ($mxs as $dom_mx)
					{
						$dom_mx=rtrim($dom_mx,'.');
						$mx_ips=array();
						exec("dig A $dom_mx @$dns_recursor | grep '^$dom_mx' | grep -E '[^ \t]*[ \t]*[0-9]*[ \t]*IN[ \t]*A' | awk '{print $5}'", $mx_ips);
						if (count($mx_ips)>0)
						{
							if (!in_array_array($local['ips'], $mx_ips))
							{
								$test['mx']=0;
							}
							else
							{
								$test['mx']=1;
								break;
							}
						}
						else
						{
							$test['mx']=0;
						}
					}
				}
			}
			else
			{
				$test['mx']=0;
			}
		}
		else
		{
			//nxdomain?
			$nsraw_arr=array();
			exec("dig NS $domain @$dns_nic", $nsraw_arr);
			$nsraw=implode("\n",$nsraw_arr);
			if (strpos($nsraw, "status: NXDOMAIN"))
			{
				$test['exist']=0;
				$test['ns']=0;
				$test['a']=0;
				$test['mx']=0;
			}
			elseif (strpos($nsraw, "status: SERVFAIL"))
			{
				$test['error']=0;
			}
		}
		if (!$test['exist'])
		{
			echo "NXDOM   ";
			$test['summary']=0;
		}
		elseif (!$test['error'])
		{
			echo "NSFAIL  ";
			$test['summary']=999;
		}
		else
		{
			$test['summary']=$test['ns']+$test['a']+$test['mx'];
			if ($test['ns'])	{ echo "NS "; } else { echo "-- "; }
			if ($test['a'])		{ echo "A "; } else { echo "- "; }
			if ($test['mx'])	{ echo "MX "; } else { echo "-- "; }
		}
		echo $domain;

		if ($test['summary']==0)
		{
			echo " *DELETE*";
//			$rdres=DBquery("UPDATE `domain` SET `active`=0 WHERE `id`='$domainid' AND `name`!='null.null';");
		}
		elseif ($test['ns']==0)
		{
			echo " *NSOFF*";
//			$rdres=DBquery("UPDATE `domain` SET `dns`=0 WHERE `id`='$domainid' AND `name`!='null.null';");
		}

		echo "\n";

#		if ($test['exist']==1 && $test['error']==1 && $test['summary']<3)
#		{
#			system("dig ANY $domain @$dns_recursor");
#		}

	}

exit (0);
