#!/usr/bin/php
<?php

/// init
	global $ini;
	global $node;

	require(dirname(__FILE__)."/../include/functions.php");
	init(1);

### Parse command line args

	$cliname='';
	if (count($argv)>1)
	{
		$cliname=$argv[1];
	}

### Get ini data

	$mailroot=$ini['global']['mailroot'];

	$chrdir='';
	if (array_key_exists('chrdir',$ini['dovecot']))
	{
		$chrdir=$ini['dovecot']['chrdir'];
	}

	$cmailroot=$chrdir.$mailroot;

### Functions

function create_maildir($dir)
{
	if (!(is_dir($dir)))
	{
		echo "Creating $dir\n";
		mkdir ($dir, 0700);
		chown ($dir, 'mail');
		chgrp ($dir, 'mail');
	}
}

### Collect mailboxes per client

	$sql="SELECT
		CONCAT(
			mail_users.name,
			'@',
			IF((dom_host.host IS NULL), '', CONCAT(dom_host.host,'.')),
			domain.name
		) AS email,
			mail_users.name AS username,
			CONCAT ( IF((dom_host.host IS NULL), '', CONCAT(dom_host.host,'.')), domain.name ) AS hostdom,
			domain.name AS domname,
			dom_host.host AS hostname,
			client.id AS cliid,
			client.name AS cliname

		FROM mail_users
			LEFT JOIN domain ON mail_users.domainid=domain.id
			LEFT JOIN dom_host ON dom_host.id=mail_users.hostid
			LEFT JOIN client ON domain.clientid=client.id
		WHERE 1
		AND `client`.`active`=1
		AND `domain`.`active`=1
	";

	if ($cliname)
	{
		$sql.="
		AND `client`.`name`='$cliname'
			";
	}

	$sql.="
		ORDER BY `client`.`name`
	;";


	$res=DBquery($sql);

	if (strlen($mailroot)>1 && (is_dir($cmailroot)))
	{
		while ($row=$res->fetch_assoc())
		{
			$email=$row['email'];
			$username=$row['username'];
			$clid=$row['cliid'];
			$clname=$row['cliname'];
			$domname=$row['domname'];
			$hostdom=$row['hostdom'];

			create_maildir($cmailroot."/".$hostdom);
			create_maildir($mbdir=$cmailroot."/".$hostdom."/".$username);
			create_maildir($mbdir=$cmailroot."/".$hostdom."/".$username."/Maildir");
		}
	}
	else
	{
		echo "Mailroot error\n";
	}

DBclose();
