#!/usr/bin/php
<?php

/// init
	global $ini;
	global $node;

	require(dirname(__FILE__)."/../include/functions.php");
	init(1);

### Parse command line args

	$cliname='';
	$domname='';
	if (count($argv)>1)
	{
		$clidomname=$argv[1];

		$csql="SELECT id FROM client WHERE name='$clidomname';";
		$cres=DBquery($csql);
		if($cres->num_rows>0)
		{
			$cliname=$clidomname;
		}
		else
		{
			$domname=$clidomname;
		}
	}


### Collect mailboxes per client

	$sql="SELECT
			(vhosts.active=1 AND domain.active=1 AND client.active=1) AS active,
			IFNULL(domain.name, '???') AS domname,
			vhosts.host AS vhname,
			IFNULL(vhosts.alias,'') AS aliases,
			IFNULL(vhosts.ext_alias,'') AS extaliases,
			IFNULL(vhosts.docroot,'') AS docroot,
			IFNULL(vhosts.redirect,'') AS redirect,
			vhosts.redirect_permanent AS redirect_permanent,
			IFNULL(vhosts.writable,'') AS writable,
			vhosts.upstream AS upstream,
			IFNULL(vhosts.extradir,'') AS extradir,
			IF(vhosts.ssl_on>0,1,0) AS ssl_on,
			IF(vhosts.ssl_mode=1,1,0) AS ssl_mode,
			IFNULL(vhosts.settings,'') AS settings,
			IFNULL(vhosts.nsettings,'') AS nsettings

		FROM vhosts
			LEFT JOIN domain ON vhosts.domainid=domain.id
			LEFT JOIN client ON domain.clientid=client.id

		WHERE 1

	";

	if ($cliname!='')
	{
		$sql.="
		AND `client`.`name`='$cliname'
			";
	}

	if ($domname!='')
	{
		$sql.="
		AND `domain`.`name`='$domname'
			";
	}

	$sql.="
		ORDER BY `client`.`name`, `domain`.`name`, `vhosts`.`host`
	;";

	$res=DBquery($sql);

	$S=';';

	while ($row=$res->fetch_assoc()) {

		// CSV mezők: domain;host;[alias1,...];[külső_alias1,...];[index_root];[átirányítás];[írható_dir1,...];[engine];[extradir];[ssl_on];[ssl_mode];[apache_settings_base64];[nginx_settings_base64]
		// CSV info: engine: [80=PHP 8.0]...[53=PHP 5.3]

		if (!$row['active']) { echo "<INAKTIV>"; }

		echo $row['domname'].$S;
		echo $row['vhname'].$S;

		$aliases_clean=str_replace(array("\r", "\t"), '', $row['aliases']);
		$aliasarr=explode("\n",$aliases_clean);
		echo implode(',', $aliasarr).$S;

		$extaliases_clean=str_replace(array("\r", "\t"), '', $row['extaliases']);
		$extaliasarr=explode("\n",$extaliases_clean);
		echo implode(',', $extaliasarr).$S;

		echo $row['docroot'].$S;
		echo $row['redirect'].$S;
		echo $row['redirect_permanent'].$S;

		$writable_clean=str_replace(array("\r", "\t"), '', $row['writable']);
		$writablearr=explode("\n",$writable_clean);
		echo implode(',', $writablearr).$S;

		echo $row['upstream'].$S;

		$extradir_clean=str_replace(array("\r", "\t"), '', $row['extradir']);
		$extradirarr=explode("\n",$extradir_clean);
		echo implode(',', $extradirarr).$S;

		echo $row['ssl_on'].$S;
		echo $row['ssl_mode'].$S;

		echo base64_encode($row['settings']).$S;

		echo base64_encode($row['nsettings']);

		echo "\n";
	}

DBclose();
