server {

	listen 80;

{if $https eq '1'}
	listen {$node_ip}:443 ssl http2;
	ssl_certificate_key {$sslkeydir}/{$ssl_key};
	ssl_certificate {$sslkeydir}/{$ssl_cert};
{/if}

	set $usport {$upstream_port};

	server_name
		{$host}.{$domain}
{if $host eq 'www'}
		{$domain}
{else}
		www.{$host}.{$domain}
{/if}

{foreach $aliases as $alias}
		{$alias}.{$domain}
{if $alias eq 'www'}
		{$domain}
{elseif ! $alias|strstr:'*'}
		www.{$alias}.{$domain}
{/if}
{/foreach}

{foreach $ext_aliases as $alias}
		{$alias}
{/foreach}

{foreach $ext_aliases_www as $alias}
		{$alias}
{/foreach}

		{$host}.{$domain}.{$def_domain}
		{$host}.{$domain}.{$node}.{$def_domain}
	;

	root {$webroot}/{$client}/{$domain}/{$host}/{$root};

#	access_log /var/log/nginx/vhosts/{$host}.{$domain}-access.log main;
	access_log off;

{if $ssl_mode eq '1'}
	if ($scheme = 'http') { return {$redirect_code} https://$host$request_uri; }
{/if}

{$nsettings}

	include "custom-vhost.conf";

{foreach $writabledirs as $wrdir}
	location ~* ^/{$wrdir}/(.+)\.ph(p[1-9s]?|tml).?$ { deny all; }
{/foreach}

	location ^~ /{$token}/stat {
		alias {$webroot}/sys/stat/{$host}.{$domain};
		access_log off;
	}

}
