server {

	listen 80;

{if $https eq '1'}
	listen {$node_ip}:443 ssl http2;
	ssl_certificate_key {$sslkeydir}/{$ssl_key};
	ssl_certificate {$sslkeydir}/{$ssl_cert};
{/if}

	server_name
		{$host}.{$domain}
{if $host eq 'www'}
		{$domain}
{else}
		www.{$host}.{$domain}
{/if}

{foreach $aliases as $alias}
		{$alias}.{$domain}
{if $alias eq 'www'}
		{$domain}
{elseif ! $alias|strstr:'*'}
		www.{$alias}.{$domain}
{/if}
{/foreach}

{foreach $ext_aliases as $alias}
		{$alias}
{/foreach}

{foreach $ext_aliases_www as $alias}
		{$alias}
{/foreach}

		{$host}.{$domain}.{$def_domain}
		{$host}.{$domain}.{$node}.{$def_domain}
	;

	access_log off;

{$nsettings}

	location = / { return {$redirect_code} {$redirect}; }
	location / { return {$redirect_code} {$redirect}$request_uri; }

##########################################################

	location ^~ /.well-known/acme-challenge {
		auth_basic off;
		allow all;
		alias /web/sys/acme;
	}

	location ^~ /.well-known/pki-validation {
		auth_basic off;
		allow all;
		alias /web/sys/acme;
	}

}
