;
; ZONE {$name}
;
$TTL	1800
@	IN	SOA	ns1.{$def_domain}. postmaster.{$def_domain}. (
			{$serial}	; Serial
			1800		; Refresh
			429		; Retry
			2419200		; Expire
			3600 )		; Negative Cache TTL
;
@		IN	NS	ns1.{$def_domain}.
		IN	NS	{$sec_ns}.
		IN	A	{$ip}
{foreach $mxarray as $mxl}
		IN	MX	{$mxl}
{/foreach}

		IN	TXT	{"v=spf1 {foreach $allips as $ip}ip4:{$ip} {/foreach} a mx {$spf_extra} {$spf}"|split_domrec_txt}

{if $mx==$defmx}
_submission._tcp	SRV	0 1 587 mail.{$def_domain}.
_submissions._tcp	SRV	0 1 465 mail.{$def_domain}.
_imap._tcp		SRV	0 1 143 mail.{$def_domain}.
_imaps._tcp		SRV	0 1 993 mail.{$def_domain}.
_pop3._tcp		SRV	0 1 110 mail.{$def_domain}.
_pop3s._tcp		SRV	0 1 995 mail.{$def_domain}.
{/if}

{foreach $opendkim_keys as $selector => $value}
{$selector}._domainkey	TXT	{$value}
{/foreach}

_dmarc			TXT	"v=DMARC1; {$dmarc}"

{$def_host}			A	{$def_ip}
			MX	{$defmx}
			TXT	"v=spf1 ip4:{$def_ip} -all"
{foreach $opendkim_keys as $selector => $value}
{$selector}._domainkey.{$def_host}	CNAME	{$selector}._domainkey
{/foreach}
_dmarc.{$def_host}	TXT	"v=DMARC1; {$dmarc}"
*.{$def_host}			A	{$def_ip}
*.{$def_host}			TXT	"v=spf1 -all"

{$def_host}{$node}			A	{$domain_node_ip}
			MX	{$defmx}
			TXT	"v=spf1 ip4:{$domain_node_ip} -all"
{foreach $opendkim_keys as $selector => $value}
{$selector}._domainkey.{$def_host}{$node}	CNAME	{$selector}._domainkey
{/foreach}
_dmarc.{$def_host}{$node}	TXT	"v=DMARC1; {$dmarc}"
*.{$def_host}{$node}			A	{$domain_node_ip}
*.{$def_host}{$node}			TXT	"v=spf1 -all"

{foreach $hosts as $hostl}
{$hostl['host']}			A	{$hostl['ip']}
{foreach $hostl['mxarray'] as $mxh}
			MX	{$mxh}
{/foreach}
			TXT	{"v=spf1 {foreach $hostl['allips'] as $hip}ip4:{$hip} {/foreach} a mx {$spf_extra} {$spf}"|split_domrec_txt}
{if strpos($hostl['host'], '*') === false}
{foreach $opendkim_keys as $selector => $value}
{$selector}._domainkey.{$hostl['host']}	CNAME	{$selector}._domainkey
{/foreach}
_dmarc.{$hostl['host']}	TXT	"v=DMARC1; {$dmarc}"
*.{$hostl['host']}			A	{$hostl['ip']}
*.{$hostl['host']}			TXT	"v=spf1 -all"
{/if}

{/foreach}

{foreach $records as $rec}
{$rec['host']}	{$rec['type']}	{$rec['value']}
{/foreach}

*			A	{$ip}
*			TXT	"v=spf1 -all"
